property script_author : "Jonathan Nathan"
property script_name : "Quizzer"
property script_version : "1.0b1"
property script_release_date : date "Monday, September 1, 2003 7:30:00 PM"
property script_copyright : ("" & ((year of script_release_date) as string) & " " & script_author & ". All rights reserved.")
property script_thanks : ""

property script_url : "http://homepage.mac.com/jonn8/as/"
property script_email : "mailto:Jonathan%20Nathan%20%3Cjonn8%40mac.com%3E?subject=Re:Quizzer"

property quitting : false
property allow_quitting : false

property quiz_list_data : null
property all_questions : {}
property all_answers : {}

property display_delete_row_alert : true
property use_quiz_timer : true
property randomize_questions : true
property ask_questions_only_once_per_quiz : true

property elapsed_time : 0
property queston_count : 1
property questions_correct : 0
property questions_incorrect : 0
property asked_questions : {}
property timer_active : false

on will finish launching the_object
	set object_name to name of the_object as string
	my update_status("will finish launching " & object_name)
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as string))
	activate
	show window "main"
	set allow_quitting to true
end launched

on should quit after last window closed the_object
	quit_prep()
	return allow_quitting
end should quit after last window closed

on quit_prep()
	my update_status("saving prefs")
	set all_questions to (contents of data cell "question" of every data row of quiz_list_data)
	set all_answers to (contents of data cell "answer" of every data row of quiz_list_data)
	write_settings()
end quit_prep

on awake from nib the_object
	set object_name to name of the_object as string
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			set contents of text view 1 of scroll view "question" to ""
			set contents of text view 1 of scroll view "answer" to ""
		end tell
		set quiz_list_data to data source of table view "quiz_list" of scroll view "quiz_list" of window "main"
		tell quiz_list_data
			make new data column at the end of the data columns with properties {name:"question"}
			make new data column at the end of the data columns with properties {name:"answer"}
		end tell
		register_settings()
		read_settings()
		repeat with i from 1 to count of all_questions
			set the_row to make new data row at the end of data rows of quiz_list_data
			set contents of data cell "question" of the_row to (item i of all_questions)
			set contents of data cell "answer" of the_row to (item i of all_answers)
		end repeat
		
	else if object_name = "quiz" then
		tell the_object
			set contents of text view 1 of scroll view "question" to ""
			set contents of text view 1 of scroll view "answer" to ""
			set contents of text field "question_count" to ""
			set contents of text field "correct_count" to ""
			set contents of text field "elapsed_time" to ""
		end tell
		
	else if object_name = "prefs" then
		tell the_object
			if display_delete_row_alert = true then
				set state of button "pref_display_delete_row_alert" to 1
			else
				set state of button "pref_display_delete_row_alert" to 0
			end if
			if use_quiz_timer = true then
				set state of button "pref_use_quiz_timer" to 1
			else
				set state of button "pref_use_quiz_timer" to 0
			end if
			if randomize_questions = true then
				set state of button "pref_randomize_questions" to 1
			else
				set state of button "pref_randomize_questions" to 0
			end if
			if ask_questions_only_once_per_quiz = true then
				set state of button "pref_ask_questions_only_once_per_quiz" to 1
			else
				set state of button "pref_ask_questions_only_once_per_quiz" to 0
			end if
		end tell
		
	else if object_name = "about" then
		tell the_object
			center
			set contents of text field "title" to (script_name & " v" & script_version)
			set contents of text field "author" to ("by " & script_author)
			set contents of text field "release" to ("Released " & script_release_date as string)
			set contents of text field "copyright" to (script_copyright)
			set contents of text field "thanks" to (script_thanks)
		end tell
		
	end if
end awake from nib

on activated the_object
	set object_name to name of the_object as string
	my update_status("activated " & object_name)
end activated

on choose menu item the_object
	set object_name to name of the_object as string
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		show window "about"
		
	else if object_name = "prefs" then
		show window "prefs"
		
	else if object_name = "quit" then
		quit_prep()
		quit
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as string
	my update_status("clicked " & object_name)
	if object_name = "quit" then
		quit_prep()
		quit
		
	else if object_name = "prefs" then
		show window "prefs"
		
	else if object_name = "about_webpage" then
		open location script_url
		
	else if object_name = "about_email" then
		open location script_email
		
	else if object_name = "quiz_list" then
		tell window "main"
			set table_view to table view "quiz_list" of scroll view "quiz_list"
			set selected_data_rows to selected data rows of table_view
			if (count of selected_data_rows) = 0 then return
			set the_row to (item 1 of selected_data_rows)
			set question to (contents of data cell "question" of the_row) as string
			set answer to (contents of data cell "answer" of the_row) as string
			set contents of text view 1 of scroll view "question" to question
			set contents of text view 1 of scroll view "answer" to answer
			set first responder to text view 1 of scroll view "question"
		end tell
		
	else if object_name = "add_row" then
		tell window "main"
			set question to (contents of text view 1 of scroll view "question") as string
			set answer to (contents of text view 1 of scroll view "answer") as string
		end tell
		if question = "" or answer = "" then
			beep
			display alert "Add Error" as critical message "You have not entered both a question and an answer. Please try again." default button "OK"
			return
		end if
		set the_row to make new data row at the end of data rows of quiz_list_data
		tell window "main"
			set contents of data cell "question" of the_row to question
			set contents of data cell "answer" of the_row to answer
			set table_view to table view "quiz_list" of scroll view "quiz_list"
			tell table_view to update
			set contents of text view 1 of scroll view "question" to ""
			set contents of text view 1 of scroll view "answer" to ""
			set first responder to text view 1 of scroll view "question"
		end tell
		
	else if object_name = "update_row" then
		tell window "main"
			set question to (contents of text view 1 of scroll view "question") as string
			set answer to (contents of text view 1 of scroll view "answer") as string
		end tell
		if question = "" or answer = "" then
			beep
			display alert "Update Error" as critical message "You have not entered both a question and an answer. Please try again." default button "OK"
			return
		end if
		tell window "main"
			set table_view to table view "quiz_list" of scroll view "quiz_list"
			set selected_data_rows to selected data rows of table_view
			if (count of selected_data_rows) = 0 then
				beep
				display alert "Update Error" as critical message "You have not selected a row to update. Select a row and try again." default button "OK"
				return
			end if
		end tell
		tell window "main"
			set the_row to (item 1 of selected_data_rows)
			set contents of data cell "question" of the_row to question
			set contents of data cell "answer" of the_row to answer
			set table_view to table view "quiz_list" of scroll view "quiz_list"
			tell table_view to update
			set contents of text view 1 of scroll view "question" to ""
			set contents of text view 1 of scroll view "answer" to ""
			set first responder to text view 1 of scroll view "question"
		end tell
		
	else if object_name = "delete_row" then
		tell window "main"
			set table_view to table view "quiz_list" of scroll view "quiz_list"
			set selected_data_rows to selected data rows of table_view
			if (count of selected_data_rows) = 0 then
				beep
				display alert "Delete Error" as critical message "You have not selected a row to delete. Select a row and try again." default button "OK"
				return
			end if
		end tell
		if display_delete_row_alert = true then
			set the_button to button returned of (display alert "Delete Current Row" as critical message "There is no undoing a delete. Are you certain you want to delete this row?" default button "Cancel" alternate button "Delete")
		else
			set the_button to "Delete"
		end if
		if the_button = "Delete" then
			tell window "main"
				my update_status("deleting selected row")
				delete (item 1 of selected_data_rows)
				tell table_view to update
				set contents of text view 1 of scroll view "question" to ""
				set contents of text view 1 of scroll view "answer" to ""
				set first responder to text view 1 of scroll view "question"
			end tell
		end if
		
		
	else if object_name = "start_quiz" then
		start_quiz()
		show window "quiz"
		hide window "main"
		
	else if object_name = "load" then
		set timer_active to false
		show window "main"
		hide window "quiz"
		
	else if object_name = "restart_quiz" then
		start_quiz()
		
	else if object_name = "correct" then
		check_answer()
		
	else if object_name starts with "pref" then
		if (state of the_object) = 1 then
			set the_sel to true
		else
			set the_sel to false
		end if
		if object_name = "pref_display_delete_row_alert" then
			set display_delete_row_alert to the_sel
		else if object_name = "pref_use_quiz_timer" then
			set use_quiz_timer to the_sel
		else if object_name = "pref_randomize_questions" then
			set randomize_questions to the_sel
		else if object_name = "pref_ask_questions_only_once_per_quiz" then
			set ask_questions_only_once_per_quiz to the_sel
		end if
	end if
end clicked

on start_quiz()
	set queston_count to 1
	set questions_correct to 0
	set questions_incorrect to 0
	set elapsed_time to 0
	set timer_active to true
	set asked_questions to {}
	set all_questions to (contents of data cell "question" of every data row of quiz_list_data)
	set all_answers to (contents of data cell "answer" of every data row of quiz_list_data)
	tell window "quiz"
		if ask_questions_only_once_per_quiz = true then
			set contents of text field "question_count" to "Question 1 of " & (count of all_questions)
		else
			set contents of text field "question_count" to "Question 1"
		end if
		set contents of text field "correct_count" to "Correct: 0 Incorrect: 0"
		if use_quiz_timer = true then
			set contents of text field "elapsed_time" to "Elapsed Time: 0 Seconds"
		else
			set contents of text field "elapsed_time" to ""
		end if
		if randomize_questions = true then
			set contents of text view 1 of scroll view "question" to some item of all_questions
		else
			set contents of text view 1 of scroll view "question" to item 1 of all_questions
		end if
		set contents of text view 1 of scroll view "answer" to ""
		set enabled of button "correct" to true
	end tell
end start_quiz

on check_answer()
	set all_question_count to (count of all_questions)
	set quiz_end to false
	tell window "quiz"
		set question to contents of text view 1 of scroll view "question"
		set answer to contents of text view 1 of scroll view "answer"
	end tell
	repeat with i from 1 to all_question_count
		if (item i of all_questions) = question then
			if (item i of all_answers) = answer then
				set correct to true
			else
				set correct to false
			end if
			exit repeat
		end if
	end repeat
	tell window "quiz"
		if correct = true then
			set queston_count to (queston_count + 1)
			set questions_correct to (questions_correct + 1)
			if ask_questions_only_once_per_quiz = true then
				if queston_count > all_question_count then
					set queston_count to all_question_count
					set quiz_end to true
				end if
				set contents of text field "question_count" to "Question " & (queston_count as string) & " of " & all_question_count
			else
				set contents of text field "question_count" to "Question " & (queston_count as string)
			end if
			set contents of text field "correct_count" to "Correct: " & (questions_correct as string) & " Incorrect: " & (questions_incorrect as string)
			if quiz_end = false then
				if randomize_questions = true then
					if ask_questions_only_once_per_quiz = false then
						set contents of text view 1 of scroll view "question" to some item of all_questions
					else
						copy (contents of text view 1 of scroll view "question") to end of asked_questions
						repeat
							set next_question to some item of all_questions
							if asked_questions does not contain next_question then exit repeat
						end repeat
						set contents of text view 1 of scroll view "question" to next_question
					end if
				else
					set contents of text view 1 of scroll view "question" to item queston_count of all_questions
				end if
				set contents of text view 1 of scroll view "answer" to ""
			else
				set timer_active to false
				set enabled of button "correct" to false
				set contents of text view 1 of scroll view "question" to "Congratulations, youve finished the quiz!"
				set contents of text view 1 of scroll view "answer" to ""
			end if
		else
			set questions_incorrect to (questions_incorrect + 1)
			set contents of text field "question_count" to "Question " & (queston_count as string) & " of " & all_question_count
			set contents of text field "correct_count" to "Correct: " & (questions_correct as string) & " Incorrect: " & (questions_incorrect as string)
		end if
	end tell
end check_answer

on action the_object
	set object_name to name of the_object as string
	my update_status("action " & object_name)
end action

on selection changed the_object
	set object_name to name of the_object as string
	my update_status("selection changed " & object_name)
end selection changed

on idle the_object
	if timer_active = true then
		set elapsed_time to elapsed_time + 1
		if use_quiz_timer = true then
			set contents of text field "elapsed_time" of window "quiz" to "Elapsed Time: " & (elapsed_time as string) & " Seconds"
		else
			set contents of text field "elapsed_time" of window "quiz" to ""
		end if
	end if
	return 1
end idle

on update_status(the_message)
	log the_message
end update_status

on register_settings()
	tell user defaults
		make new default entry at end of default entries with properties {name:"display_delete_row_alert", contents:display_delete_row_alert}
		make new default entry at end of default entries with properties {name:"use_quiz_timer", contents:use_quiz_timer}
		make new default entry at end of default entries with properties {name:"randomize_questions", contents:randomize_questions}
		make new default entry at end of default entries with properties {name:"ask_questions_only_once_per_quiz", contents:ask_questions_only_once_per_quiz}
		make new default entry at end of default entries with properties {name:"all_questions", contents:all_questions}
		make new default entry at end of default entries with properties {name:"all_answers", contents:all_answers}
		register
	end tell
end register_settings

on read_settings()
	tell user defaults
		set display_delete_row_alert to contents of default entry "display_delete_row_alert"
		set use_quiz_timer to contents of default entry "use_quiz_timer"
		set randomize_questions to contents of default entry "randomize_questions"
		set ask_questions_only_once_per_quiz to contents of default entry "ask_questions_only_once_per_quiz"
		set all_questions to contents of default entry "all_questions"
		set all_answers to contents of default entry "all_answers"
	end tell
end read_settings

on write_settings()
	tell user defaults
		set contents of default entry "display_delete_row_alert" to display_delete_row_alert
		set contents of default entry "use_quiz_timer" to use_quiz_timer
		set contents of default entry "randomize_questions" to randomize_questions
		set contents of default entry "ask_questions_only_once_per_quiz" to ask_questions_only_once_per_quiz
		set contents of default entry "all_questions" to all_questions
		set contents of default entry "all_answers" to all_answers
	end tell
end write_settings
